VERSION 5.00
Begin VB.Form Form1 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Macro Font Example"
   ClientHeight    =   3255
   ClientLeft      =   1590
   ClientTop       =   1545
   ClientWidth     =   6315
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3255
   ScaleWidth      =   6315
   ShowInTaskbar   =   0   'False
   Begin VB.ListBox List1 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   480
      Left            =   5040
      TabIndex        =   6
      Top             =   2700
      Width           =   1215
   End
   Begin VB.PictureBox Picture1 
      BackColor       =   &H00FFFFFF&
      Height          =   1695
      Left            =   60
      ScaleHeight     =   1635
      ScaleWidth      =   11775
      TabIndex        =   5
      Top             =   3300
      Width           =   11835
   End
   Begin VB.TextBox SecondType 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1140
      TabIndex        =   2
      Top             =   2940
      Width           =   1635
   End
   Begin VB.TextBox FirstType 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   1140
      TabIndex        =   1
      Top             =   2640
      Width           =   1635
   End
   Begin VB.TextBox OutPutTxt 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2535
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Both
      TabIndex        =   0
      Top             =   60
      Width           =   6195
   End
   Begin VB.Label Label3 
      Caption         =   "Font List box for second macro font type:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3120
      TabIndex        =   7
      Top             =   2700
      Width           =   1815
   End
   Begin VB.Label Label2 
      Caption         =   "Second Type:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   4
      Top             =   2940
      Width           =   1035
   End
   Begin VB.Label Label1 
      Caption         =   "First Type:"
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   60
      TabIndex        =   3
      Top             =   2640
      Width           =   1035
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Macro Font Example
' PAT or JK
' 12.21.99
' http://www.patorjk.com/

' This is an example that shows you 2 ways on
' how to do macro fonts for macro shops. This
' example used to be just a code example in my
' 32 bit library section, but I thought I'd make
' it into an example since a lot of people were
' having trouble with it.

Option Explicit
' this function returns the long value of the
' color of a pixel
Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long) As Long

' private variables for the first type
Dim MFontName As String
Dim FontAuthor As String
Dim MFontSize As Integer
Dim MacroFont(1 To 27, 1 To 20) As String

Private Sub FirstType_Change()
    Dim i As Integer, i2 As Integer, x$, itspos, MacWord As String
    ' figure out which letters to make, and
    ' then make them.
    x$ = "ABCDEFGHIJKLMNOPQRSTUVWXYZ "
    For i2 = 1 To MFontSize
        For i = 1 To Len(FirstType)
            itspos = InStr(x$, UCase$(Mid$(FirstType, i, 1)))
            If itspos <> 0 Then
                MacWord = MacWord + MacroFont(itspos, i2)
            End If
        Next
        MacWord = MacWord + Chr$(13) + Chr$(10)
    Next
    OutPutTxt.Text = MacWord
End Sub

Private Sub Form_Load()
    Dim MFontName As String, FilePath As String
    Dim x As String, i As Integer, i2 As Integer
    
    ' load the fonts on the person's computer
    ' into a listbox
    For i = 0 To Screen.FontCount - 1
        List1.AddItem Screen.Fonts(i)
    Next
    
    ' get the font files path
    If Right(App.Path, 1) = "\" Then
        FilePath = App.Path
    Else
        FilePath = App.Path & "\"
    End If
    MFontName = FilePath & "Bent.pmf"
    
    ' load the font file we want to use.
    ' What's happening here is that the macro
    ' font is saved in a certain format. All
    ' the letters are placed a certain way
    ' so they can be loaded into the array.
    Open MFontName For Input As #1
    Line Input #1, x
    MFontSize = Val(Mid$(x, 19))
    If FontSize < 1 Then Exit Sub
    Line Input #1, x
    FontAuthor = Mid$(x, 21)
    
    For i = 1 To 26
        For i2 = 1 To MFontSize
            Line Input #1, x
            MacroFont(i, i2) = x
        Next
    Next
    
    For i = 1 To MFontSize
        MacroFont(27, i) = "     "
    Next
    Close #1

End Sub

Private Sub List1_Click()
    Picture1.Font = List1.List(List1.ListIndex)
End Sub

Private Sub SecondType_Change()
    Dim i As Integer, i2 As Integer
    Dim PicColor As Long, hold As String
    
    ' set the picture info that we need
    Picture1.Picture = Me.Picture
    Picture1.Cls
    Picture1.AutoRedraw = True
    Picture1.ScaleMode = 3
    Picture1.FontSize = 32
    ' print the text onto the picture
    Picture1.Print SecondType.Text
    
    OutPutTxt.Text = ""
        
    ' Loop through the pixels on the picture.
    ' As we do this we place text in the OutPutTxt
    ' textbox depending on the color of the pixel
    For i = 1 To Picture1.TextHeight(SecondType.Text) Step 4
        For i2 = 1 To Picture1.TextWidth(SecondType.Text) Step 4
            PicColor = GetPixel(Picture1.hdc, i2, i)
            If PicColor <= RGB(25, 25, 25) Then
                hold = hold + ";;"
            ElseIf PicColor <= RGB(100, 100, 100) Then
                hold = hold + "::"
            ElseIf PicColor <= RGB(200, 200, 200) Then
                hold = hold + "''"
            Else
                hold = hold + "  "
            End If
        Next
        ' make sure we're not just going to add
        ' a blank line.
        If InStr(hold, ";") <> 0 Or InStr(hold, ":") <> 0 Or InStr(hold, "'") <> 0 Then
            OutPutTxt.Text = OutPutTxt.Text + hold + vbNewLine
        End If
        hold = ""
    Next
    
    ' note that the picturebox we're using can only
    ' hold so much text in it before the text in
    ' it goes off screen.
End Sub
